#ifndef MILLER_RABIN_HPP
#define MILLER_RABIN_HPP

class MillerRabin : boost::noncopyable {
public:
  static void Init(unsigned nTrials);
  MillerRabin();
  ~MillerRabin();
  bool Test(mpz_t number, gmp_randstate_t rand);

private:
  static unsigned nTrials_;
  unsigned s_;
  mpz_t minus1_, d_, x_;

  bool Trial(mpz_t number, gmp_randstate_t rand);
};

#endif // MILLER_RABIN_HPP
