#ifndef SEARCH_HPP
#define SEARCH_HPP

inline void RandomNumber(mpz_t rop, gmp_randstate_t rand, unsigned size) {
  mpz_urandomb(rop, rand, size);
  mpz_setbit(rop, 0);
  mpz_setbit(rop, size - 1);
}

unsigned SimpleSearch(mpz_t rop, unsigned size, unsigned long seed);

unsigned ThreadedSearch(mpz_t rop, unsigned size, unsigned long seed,
                        unsigned nThreads);

unsigned MpiSearch(mpz_t rop, unsigned size, unsigned long seed,
                   int *argc, char **argv[]);

unsigned OmpSearch(mpz_t rop, unsigned size, unsigned long seed);

#endif // SEARCH_HPP
