#include "Common.hpp"
#include "Search.hpp"
#include "TrialDivision.hpp"
#include "MillerRabin.hpp"

unsigned SimpleSearch(mpz_t rop, unsigned size, unsigned long seed) {
  gmp_randstate_t genRand, mrRand;
  mpz_t number;
  TrialDivision trial;
  MillerRabin mr;

  gmp_randinit_default(genRand);
  gmp_randseed_ui(genRand, seed);
  gmp_randinit_default(mrRand);
  gmp_randseed_ui(mrRand, seed);
  mpz_init(number);

  unsigned processed = 0;
  do {
    RandomNumber(number, genRand, size);
    ++processed;
  } while (!trial.Test(number) || !mr.Test(number, mrRand));

  mpz_swap(rop, number);
  gmp_randclear(genRand);
  gmp_randclear(mrRand);
  mpz_clear(number);
  return processed;
}
