#ifndef THREAD_WORKER
#define THREAD_WORKER

#include "Worker.hpp"

class ThreadWorker : public Worker {
public:
  ThreadWorker(unsigned size, unsigned long seed, unsigned threads);
  ~ThreadWorker();
  virtual void Search(mpz_t rop);

protected:
  void NextCandidate(mpz_t rop);
  void Finish(mpz_t prime);

private:
  static void Thread(ThreadWorker *worker, unsigned long seed);

  unsigned long seed_;
  unsigned nThreads_;
  boost::thread_group threads_;
  boost::mutex candidateMutex_;

  mpz_t result_;
  boost::condition_variable resultCondition_;
  boost::mutex resultMutex_;
};

#endif // THREAD_WORKER
