#include "Common.hpp"
#include "TrialDivision.hpp"

unsigned TrialDivision::max_;
boost::dynamic_bitset<> TrialDivision::isPrime_;

void TrialDivision::Init(unsigned max) {
  max_ = max;
  isPrime_.resize(max / 2, true);

  unsigned maxPrime = 0;
  for (unsigned i = 3; i <= max_; i += 2) {
    if (isPrime_[i / 2 - 1]) {
      maxPrime = i;
      unsigned limit = max_ / i;
      for (unsigned j = 3; j <= limit; j += 2) {
        isPrime_.reset((i * j) / 2 - 1);
      }
    }
  }
  max_ = maxPrime;
  isPrime_.resize(max_ / 2);
}

bool TrialDivision::Test(mpz_t number) {
  for (unsigned i = 3; i <= max_; i += 2) {
    if (isPrime_[i / 2 - 1] && mpz_divisible_ui_p(number, i)) {
      return false;
    }
  }
  return true;
}
